"use strict";

var co = require('co');
const debug = require('debug');
const error = debug("dom")

const wrap = function(fn) {
  return function() {
    co.call(this, fn.apply(this, arguments)).catch(error);
  }
}


module.exports = function(jQuery) {

  jQuery.fn.cofocus = function (fn) {
    var ret = wrap(fn);
    this.focus(ret);
    return ret;
  };

  jQuery.fn.cofocusin = function (fn) {
    var ret = wrap(fn);
    this.focusin(ret);
    return ret;
  };

  jQuery.fn.cofocusout = function (fn) {
    var ret = wrap(fn);
    this.focusout(ret);
    return ret;
  };

  jQuery.fn.coresize = function (fn) {
    var ret = wrap(fn);
    this.resize(ret);
    return ret;
  };

  jQuery.fn.coscroll = function (fn) {
    var ret = wrap(fn);
    this.scroll(ret);
    return ret;
  };

  jQuery.fn.coclick = function (fn) {
    var ret = wrap(fn);
    this.click(ret);
    return ret;
  };

  jQuery.fn.codblclick = function (fn) {
    var ret = wrap(fn);
    this.dblclick(ret);
    return ret;
  };

  jQuery.fn.coready = function (fn) {
    var ret = wrap(fn);
    this.ready(ret);
    return ret;
  };

  jQuery.fn.cochange = function (fn) {
    var ret = wrap(fn);
    this.change(ret);
    return ret;
  };

  jQuery.fn.coblur = function (fn) {
    var ret = wrap(fn);
    this.blur(ret);
    return ret;
  };

  jQuery.fn.cokeypress = function (fn) {
    var ret = wrap(fn);
    this.keypress(ret);
    return ret;
  };


  jQuery.fn.comousedown = function (fn) {
    var ret = wrap(fn);
    this.mousedown(ret);
    return ret;
  };

  jQuery.fn.comouseup = function (fn) {
    var ret = wrap(fn);
    this.mouseup(ret);
    return ret;
  };

  jQuery.fn.comousemove = function (fn) {
    var ret = wrap(fn);
    this.mousemove(ret);
    return ret;
  };

  jQuery.fn.comouseover = function (fn) {
    var ret = wrap(fn);
    this.mouseover(ret);
    return ret;
  };

  jQuery.fn.comouseout = function (fn) {
    var ret = wrap(fn);
    this.mouseout(ret);
    return ret;
  };

  jQuery.fn.comouseenter = function (fn) {
    var ret = wrap(fn);
    this.mouseenter(ret);
    return ret;
  };

  jQuery.fn.comouseleave = function (fn) {
    var ret = wrap(fn);
    this.mouseleave(ret);
    return ret;
  };


  jQuery.fn.coselect = function (fn) {
    var ret = wrap(fn);
    this.select(ret);
    return ret;
  };

  jQuery.fn.cosubmit = function (fn) {
    var ret = wrap(fn);
    this.submit(ret);
    return ret;
  };

  jQuery.fn.cokeydown = function (fn) {
    var ret = wrap(fn);
    this.keydown(ret);
    return ret;
  };

  jQuery.fn.cokeyup = function (fn) {
    var ret = wrap(fn);
    this.keyup(ret);
    return ret;
  };

  jQuery.fn.cotouchstart = function(fn) {
    var ret = wrap(fn);
    this.on('touchstart', ret);
    return ret;
  }

  return jQuery;
}


      
